package dnd;

import javax.swing.*;
import java.awt.datatransfer.*;

public class ListTransferHandler extends TransferHandler 
{

        public boolean canImport(TransferSupport support) {

            if (!support.isDrop()) return false;
            return support.isDataFlavorSupported (DataFlavor.stringFlavor);
        }

        public boolean importData(TransferSupport support) {

            if (!canImport(support)) return false;
            Transferable transferable = support.getTransferable();

            String line;
            try {
               line = (String) transferable.getTransferData(DataFlavor.stringFlavor);
            } 
            catch (Exception e) {
                return false;
            }

            JList.DropLocation dl = (JList.DropLocation) support.getDropLocation();
            int index = dl.getIndex();

            JList list = (JList) support.getComponent();
            DefaultListModel model = (DefaultListModel) list.getModel();
            model.add (index++, line);

            return true;
        }
}
